# -*- Coding: utf-8 -*-

"""
iSuperpose

Miscellaneous module
"""

def aaseq2( PDB, atms = [''] ):
    """
    MJ 2008 Sept 04
    We only want residues with some selected atoms.

    Avoid some synchronisation bugs with TMalign results, 
    for some residues with no CA, ignored by TMalign but 
    not by the PDB.aaseq() method.
    """
    return PDB.select([''],atms).aaseq()


def printFloatList(stream, theList):
    """
    Prints a float list in a given stream.
    """
    debug = 0
    for a in theList:
        for b in a:
            try:
                stream.write("%.8f "%b)
                if debug:
                    print >> sys.stderr, "%.8f" %b,
            except IOError:
                print >> sys.stderr, "Broken Pipe for %f " %b
                sys.exit(0)
        stream.write("\n")
        if debug:
            print >> sys.stderr, " ok"
    stream.flush()
    return

def printFloatList2(stream, theList):
    """
    Prints a float list in a given stream.
    We prepare lines to write on a single string
    and write it once.
    """
    debug = 0
    oStr = ""
    for a in theList:        
        if not len(a):
            continue
        for b in a:
            oStr += "%.8f "%b
            if debug:
                print >> sys.stderr, "%.8f" %b,
        oStr += "\n"
        if debug:
            print >> sys.stderr, " ok"
    stream.write( "%s" % oStr )
    stream.flush()
    return
